<?php

namespace DataView;

class GruppeVerantwortlich {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderScript() { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
    function changefilter_gruppeVerantwortlich_gruppeListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_gruppeVerantwortlich_gruppe', val, cb.checked);
		  } else {
			  delete query['filter_gruppeVerantwortlich_gruppe'];
		  }reloadgruppeVerantwortlich();
        
    }

		var i75b4f46e8f9501f4197592a7cb5ac47748e3453b26456bc70f893adab55c59e0timeout = null;
		function changefilter_gruppeVerantwortlich_gruppeSearchFilter(val, callback) {
			if(i75b4f46e8f9501f4197592a7cb5ac47748e3453b26456bc70f893adab55c59e0timeout) clearTimeout(i75b4f46e8f9501f4197592a7cb5ac47748e3453b26456bc70f893adab55c59e0timeout);

			i75b4f46e8f9501f4197592a7cb5ac47748e3453b26456bc70f893adab55c59e0timeout = setTimeout(function() {
				$.getJSON(reloadgruppeVerantwortlich({action: 'getfilter_gruppeVerantwortlich_gruppeItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_gruppeVerantwortlich_gruppe_orig'] = val;
				});
			}, 300);
		}

	function getfilter_gruppeVerantwortlich_gruppeListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_gruppeVerantwortlich_gruppe_orig']) ? json_encode($_GET['filter_gruppeVerantwortlich_gruppe_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="75b4f46e8f9501f4197592a7cb5ac47748e3453b26456bc70f893adab55c59e0" type="text">' +
			'<label class="mdl-textfield__label" for="75b4f46e8f9501f4197592a7cb5ac47748e3453b26456bc70f893adab55c59e0">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_gruppeVerantwortlich_gruppe', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_gruppeVerantwortlich_gruppe_orig'] = '';
					delete query['filter_gruppeVerantwortlich_gruppe'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadgruppeVerantwortlich();
					
				} else {
					$('#table_gruppeVerantwortlich').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_gruppeVerantwortlich_gruppeSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\GruppeVerantwortlich::getfilter_gruppeVerantwortlich_gruppeItemsByStringAction(''));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_gruppeVerantwortlich_gruppe_orig'] = '';
				delete query['filter_gruppeVerantwortlich_gruppe'];
				reload('', items);reloadgruppeVerantwortlich();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_gruppeVerantwortlich_gruppe', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_gruppeVerantwortlich_gruppeListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
    function changefilter_gruppeVerantwortlich_mitgliedListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_gruppeVerantwortlich_mitglied', val, cb.checked);
		  } else {
			  delete query['filter_gruppeVerantwortlich_mitglied'];
		  }reloadgruppeVerantwortlich();
        
    }

		var i86ba9f7139e8d50dc9586c7afc0059e75daad5a9ce090f4a531e2aea950706a4timeout = null;
		function changefilter_gruppeVerantwortlich_mitgliedSearchFilter(val, callback) {
			if(i86ba9f7139e8d50dc9586c7afc0059e75daad5a9ce090f4a531e2aea950706a4timeout) clearTimeout(i86ba9f7139e8d50dc9586c7afc0059e75daad5a9ce090f4a531e2aea950706a4timeout);

			i86ba9f7139e8d50dc9586c7afc0059e75daad5a9ce090f4a531e2aea950706a4timeout = setTimeout(function() {
				$.getJSON(reloadgruppeVerantwortlich({action: 'getfilter_gruppeVerantwortlich_mitgliedItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_gruppeVerantwortlich_mitglied_orig'] = val;
				});
			}, 300);
		}

	function getfilter_gruppeVerantwortlich_mitgliedListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_gruppeVerantwortlich_mitglied_orig']) ? json_encode($_GET['filter_gruppeVerantwortlich_mitglied_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="86ba9f7139e8d50dc9586c7afc0059e75daad5a9ce090f4a531e2aea950706a4" type="text">' +
			'<label class="mdl-textfield__label" for="86ba9f7139e8d50dc9586c7afc0059e75daad5a9ce090f4a531e2aea950706a4">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_gruppeVerantwortlich_mitglied', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_gruppeVerantwortlich_mitglied_orig'] = '';
					delete query['filter_gruppeVerantwortlich_mitglied'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadgruppeVerantwortlich();
					
				} else {
					$('#table_gruppeVerantwortlich').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_gruppeVerantwortlich_mitgliedSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\GruppeVerantwortlich::getfilter_gruppeVerantwortlich_mitgliedItemsByStringAction(''));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_gruppeVerantwortlich_mitglied_orig'] = '';
				delete query['filter_gruppeVerantwortlich_mitglied'];
				reload('', items);reloadgruppeVerantwortlich();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_gruppeVerantwortlich_mitglied', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_gruppeVerantwortlich_mitgliedListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									
    function changefilter_gruppeVerantwortlich_gruppeListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_gruppeVerantwortlich_gruppe', val, cb.checked);
		  } else {
			  delete query['filter_gruppeVerantwortlich_gruppe'];
		  }reloadgruppeVerantwortlich();
        
    }

		var i75b4f46e8f9501f4197592a7cb5ac47748e3453b26456bc70f893adab55c59e0timeout = null;
		function changefilter_gruppeVerantwortlich_gruppeSearchFilter(val, callback) {
			if(i75b4f46e8f9501f4197592a7cb5ac47748e3453b26456bc70f893adab55c59e0timeout) clearTimeout(i75b4f46e8f9501f4197592a7cb5ac47748e3453b26456bc70f893adab55c59e0timeout);

			i75b4f46e8f9501f4197592a7cb5ac47748e3453b26456bc70f893adab55c59e0timeout = setTimeout(function() {
				$.getJSON(reloadgruppeVerantwortlich({action: 'getfilter_gruppeVerantwortlich_gruppeItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_gruppeVerantwortlich_gruppe_orig'] = val;
				});
			}, 300);
		}

	function getfilter_gruppeVerantwortlich_gruppeListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_gruppeVerantwortlich_gruppe_orig']) ? json_encode($_GET['filter_gruppeVerantwortlich_gruppe_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="75b4f46e8f9501f4197592a7cb5ac47748e3453b26456bc70f893adab55c59e0" type="text">' +
			'<label class="mdl-textfield__label" for="75b4f46e8f9501f4197592a7cb5ac47748e3453b26456bc70f893adab55c59e0">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_gruppeVerantwortlich_gruppe', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_gruppeVerantwortlich_gruppe_orig'] = '';
					delete query['filter_gruppeVerantwortlich_gruppe'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadgruppeVerantwortlich();
					
				} else {
					$('#table_gruppeVerantwortlich').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_gruppeVerantwortlich_gruppeSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\GruppeVerantwortlich::getfilter_gruppeVerantwortlich_gruppeItemsByStringAction(''));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_gruppeVerantwortlich_gruppe_orig'] = '';
				delete query['filter_gruppeVerantwortlich_gruppe'];
				reload('', items);reloadgruppeVerantwortlich();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_gruppeVerantwortlich_gruppe', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_gruppeVerantwortlich_gruppeListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
    function changefilter_gruppeVerantwortlich_mitgliedListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_gruppeVerantwortlich_mitglied', val, cb.checked);
		  } else {
			  delete query['filter_gruppeVerantwortlich_mitglied'];
		  }reloadgruppeVerantwortlich();
        
    }

		var i86ba9f7139e8d50dc9586c7afc0059e75daad5a9ce090f4a531e2aea950706a4timeout = null;
		function changefilter_gruppeVerantwortlich_mitgliedSearchFilter(val, callback) {
			if(i86ba9f7139e8d50dc9586c7afc0059e75daad5a9ce090f4a531e2aea950706a4timeout) clearTimeout(i86ba9f7139e8d50dc9586c7afc0059e75daad5a9ce090f4a531e2aea950706a4timeout);

			i86ba9f7139e8d50dc9586c7afc0059e75daad5a9ce090f4a531e2aea950706a4timeout = setTimeout(function() {
				$.getJSON(reloadgruppeVerantwortlich({action: 'getfilter_gruppeVerantwortlich_mitgliedItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_gruppeVerantwortlich_mitglied_orig'] = val;
				});
			}, 300);
		}

	function getfilter_gruppeVerantwortlich_mitgliedListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_gruppeVerantwortlich_mitglied_orig']) ? json_encode($_GET['filter_gruppeVerantwortlich_mitglied_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="86ba9f7139e8d50dc9586c7afc0059e75daad5a9ce090f4a531e2aea950706a4" type="text">' +
			'<label class="mdl-textfield__label" for="86ba9f7139e8d50dc9586c7afc0059e75daad5a9ce090f4a531e2aea950706a4">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_gruppeVerantwortlich_mitglied', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_gruppeVerantwortlich_mitglied_orig'] = '';
					delete query['filter_gruppeVerantwortlich_mitglied'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadgruppeVerantwortlich();
					
				} else {
					$('#table_gruppeVerantwortlich').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_gruppeVerantwortlich_mitgliedSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\GruppeVerantwortlich::getfilter_gruppeVerantwortlich_mitgliedItemsByStringAction(''));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_gruppeVerantwortlich_mitglied_orig'] = '';
				delete query['filter_gruppeVerantwortlich_mitglied'];
				reload('', items);reloadgruppeVerantwortlich();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_gruppeVerantwortlich_mitglied', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_gruppeVerantwortlich_mitgliedListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									function updateNumbergruppeVerantwortlich(col) {
										//var checklist = window.DataViewChecked['gruppeVerantwortlich'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['gruppeVerantwortlich'] && window.DataViewChecked['gruppeVerantwortlich'][col].ranges.length > 0) {
											$('.gruppeVerantwortlich__mass-action').css('visibility', 'visible');
											$('.gruppeVerantwortlich__action').css('visibility', 'hidden');
										} else {
											$('.gruppeVerantwortlich__mass-action').css('visibility', 'hidden');
											$('.gruppeVerantwortlich__action').css('visibility', 'visible');
										}
										$('.gruppeVerantwortlich__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('gruppeVerantwortlich__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('gruppeVerantwortlich__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadgruppeVerantwortlich (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/GruppeVerantwortlich/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if (((\FOP\User::getGruppe())) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/GruppeVerantwortlich/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#gruppeVerantwortlich-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#gruppeVerantwortlich-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#gruppeVerantwortlich-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumbergruppeVerantwortlich('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#gruppeVerantwortlich-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadgruppeVerantwortlich()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checkgruppeVerantwortlich (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['gruppeVerantwortlich']) window.DataViewChecked['gruppeVerantwortlich'] = {};
										if (!window.DataViewChecked['gruppeVerantwortlich'][col]) window.DataViewChecked['gruppeVerantwortlich'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['gruppeVerantwortlich'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadgruppeVerantwortlich({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['gruppeVerantwortlich'][col] = new IDList(ids);
													updateNumbergruppeVerantwortlich(col);
												});
											} else {
												window.DataViewChecked['gruppeVerantwortlich'][col] = new IDList();
												updateNumbergruppeVerantwortlich(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#gruppeVerantwortlich__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['gruppeVerantwortlich'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['gruppeVerantwortlich'][col].push(id);
												} else {
													window.DataViewChecked['gruppeVerantwortlich'][col].remove(id);
												}
											}
											updateNumbergruppeVerantwortlich(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadgruppeVerantwortlich();
			
		}

	</script>
	<?php
	
    
  }

  public static function renderTabTableAction() { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if(((\FOP\User::getGruppe()) && (\FOP\User::getGruppe())) && (!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest())) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="
		var self = this;
		event.preventDefault();
		$.get(reloadgruppeVerantwortlich({action: 'open', fop_table: 'gruppeVerantwortlich', fop_id: '_', fop_from: location.href}, true))
		.then(function () {
			window.open_url(self.href, false);
		});" href="<?php echo htmlentities(\TablesRouter\GruppeVerantwortlich::createURL2(['from' => $_GET['from'] ?? null, 'popup' => $_GET['popup'] ?? null])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), _('Gruppenverantwortlicher'))); ?></a><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_gruppeVerantwortlich']) ? intval($_GET['page_gruppeVerantwortlich']) : 0);
								$addlines = (isset($_GET['addlines_gruppeVerantwortlich']) ? intval($_GET['addlines_gruppeVerantwortlich']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'gruppe',
												'desc' => _('Gruppe'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['gruppe'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'mitglied',
												'desc' => _('Verantwortlich'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['mitglied'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('gruppeVerantwortlich'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='gruppe'
												data-order='<?php echo intval($columns['gruppe']['order']); ?>'
												data-width='<?php echo intval($columns['gruppe']['width']); ?>'
												data-collapsed='<?php echo intval($columns['gruppe']['collapsed']); ?>'
												style='width: <?php echo intval($columns['gruppe']['width']); ?>px; <?php if ($columns['gruppe']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadgruppeVerantwortlich(); 
		}});
		
		win.append(getfilter_gruppeVerantwortlich_gruppeListMultiFilter()); win.find('input').first().focus();
		return false;
	">
													<span class='title-title' title='<?php echo(_('Gruppe')); ?>'><?php echo(_('Gruppe')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_gruppeVerantwortlich']) && $_GET['sort_gruppeVerantwortlich'] == 'gruppe ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_gruppeVerantwortlich']) && $_GET['sort_gruppeVerantwortlich'] == 'gruppe DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_gruppeVerantwortlich_gruppe']) || isset($_GET['range_max_gruppeVerantwortlich_gruppe']) || isset($_GET['deps_gruppeVerantwortlich_gruppe']) || isset($_GET['fullsearch_gruppeVerantwortlich_gruppe']) || isset($_GET['dynamic_gruppeVerantwortlich_gruppe']) || isset($_GET['search_gruppeVerantwortlich_gruppe']) || isset($_GET['searchnot_gruppeVerantwortlich_gruppe']) || isset($_GET['filter_gruppeVerantwortlich_gruppe'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['gruppe']['header'] = ob_get_contents(); ob_end_clean();
											$columns['gruppe']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['gruppe']['width']); ?>px; <?php if ($columns['gruppe']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='gruppe'><?php
	
	call_user_func(function () use ($item) {
	$id = $item['gruppe'];
	$val = $item['gruppe::description'];
	$canView = $item['gruppe::canView'];
	if ($val !== null) {
		if ($canView) echo "<a tabindex=\"-1\" class=\"mdl-button mdl-button-small tbl-link\" data-tbl=\"gruppe\" data-id=\"".htmlentities($id)."\" onclick=\"event.stopPropagation(); event.preventDefault(); open_url(this.href, true);\" href=\"" . \TablesRouter\Gruppe::viewURL($id, ['from' => \FOP\Util::getBackURL()]) . "\">(…)</a>";echo htmlentities($val);
	} else {
		echo htmlentities(_('') ?: '-');
	}
	});
	
?>
</div><?php
											};
											$columns['gruppe']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='gruppe'
													data-order='<?php echo intval($columns['gruppe']['order']); ?>'
													data-width='<?php echo intval($columns['gruppe']['width']); ?>'
													data-collapsed='<?php echo intval($columns['gruppe']['collapsed']); ?>'
													style='width: <?php echo intval($columns['gruppe']['width']); ?>px; <?php if ($columns['gruppe']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='mitglied'
												data-order='<?php echo intval($columns['mitglied']['order']); ?>'
												data-width='<?php echo intval($columns['mitglied']['width']); ?>'
												data-collapsed='<?php echo intval($columns['mitglied']['collapsed']); ?>'
												style='width: <?php echo intval($columns['mitglied']['width']); ?>px; <?php if ($columns['mitglied']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadgruppeVerantwortlich(); 
		}});
		
		win.append(getfilter_gruppeVerantwortlich_mitgliedListMultiFilter()); win.find('input').first().focus();
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_gruppeVerantwortlich'] == 'mitglied ASC') {
			query['sort_gruppeVerantwortlich'] = 'mitglied DESC';
		 } else if (query['sort_gruppeVerantwortlich'] == 'mitglied DESC') {
		 	delete query['sort_gruppeVerantwortlich'];
		 } else {
			query['sort_gruppeVerantwortlich'] = 'mitglied ASC';
		 }
		 reloadgruppeVerantwortlich();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Verantwortlich')); ?>'><?php echo(_('Verantwortlich')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_gruppeVerantwortlich']) && $_GET['sort_gruppeVerantwortlich'] == 'mitglied ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_gruppeVerantwortlich']) && $_GET['sort_gruppeVerantwortlich'] == 'mitglied DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_gruppeVerantwortlich_mitglied']) || isset($_GET['range_max_gruppeVerantwortlich_mitglied']) || isset($_GET['deps_gruppeVerantwortlich_mitglied']) || isset($_GET['fullsearch_gruppeVerantwortlich_mitglied']) || isset($_GET['dynamic_gruppeVerantwortlich_mitglied']) || isset($_GET['search_gruppeVerantwortlich_mitglied']) || isset($_GET['searchnot_gruppeVerantwortlich_mitglied']) || isset($_GET['filter_gruppeVerantwortlich_mitglied'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['mitglied']['header'] = ob_get_contents(); ob_end_clean();
											$columns['mitglied']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['mitglied']['width']); ?>px; <?php if ($columns['mitglied']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='mitglied'><?php
	
	call_user_func(function () use ($item) {
	$id = $item['mitglied'];
	$val = $item['mitglied::description'];
	$canView = $item['mitglied::canView'];
	if ($val !== null) {
		if ($canView) echo "<a tabindex=\"-1\" class=\"mdl-button mdl-button-small tbl-link\" data-tbl=\"mitglied\" data-id=\"".htmlentities($id)."\" onclick=\"event.stopPropagation(); event.preventDefault(); open_url(this.href, true);\" href=\"" . \TablesRouter\Mitglied::viewURL($id, ['from' => \FOP\Util::getBackURL()]) . "\">(…)</a>";echo htmlentities($val);
	} else {
		echo htmlentities(_('') ?: '-');
	}
	});
	
?>
</div><?php
											};
											$columns['mitglied']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='mitglied'
													data-order='<?php echo intval($columns['mitglied']['order']); ?>'
													data-width='<?php echo intval($columns['mitglied']['width']); ?>'
													data-collapsed='<?php echo intval($columns['mitglied']['collapsed']); ?>'
													style='width: <?php echo intval($columns['mitglied']['width']); ?>px; <?php if ($columns['mitglied']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#gruppeVerantwortlich-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#gruppeVerantwortlich-table .fop-table-header .fop-table-column .title,
										#gruppeVerantwortlich-table .fop-column-handle,
										#gruppeVerantwortlich-table .fop-table-row,
										#gruppeVerantwortlich-table .fop-table-row .fop-table-column,
										#gruppeVerantwortlich-table .fop-table-column-multicontrol,
										#gruppeVerantwortlich-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="gruppeVerantwortlich">
											<div class="fop-legend"></div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="gruppeVerantwortlich__all-checkbox">
														<input class="mdl-checkbox__input" id="gruppeVerantwortlich__all-checkbox" type="checkbox" onchange="checkgruppeVerantwortlich('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon gruppeVerantwortlich__mass-action" style='visibility: hidden;' onclick="$.get('DataView/GruppeVerantwortlich/permissions?id=' + checkgruppeVerantwortlich(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_gruppeVerantwortlich_') == 0 || key.indexOf('range_max_gruppeVerantwortlich_') == 0 || key.indexOf('deps_gruppeVerantwortlich_') == 0 || key.indexOf('fullsearch_gruppeVerantwortlich_') == 0 || key.indexOf('dynamic_gruppeVerantwortlich_') == 0 || key.indexOf('search_gruppeVerantwortlich_') == 0 || key.indexOf('searchnot_gruppeVerantwortlich_') == 0 || key.indexOf('filter_gruppeVerantwortlich_') == 0) delete query[key]; reloadgruppeVerantwortlich(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_gruppeVerantwortlich_ID'] = checkgruppeVerantwortlich(null, 'ID'); delete query['page_gruppeVerantwortlich']; reloadgruppeVerantwortlich(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checkgruppeVerantwortlich(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checkgruppeVerantwortlich(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && ((\FOP\User::getGruppe()) && (\FOP\User::getGruppe()))) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/GruppeVerantwortlich/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checkgruppeVerantwortlich(null, 'ID'))).then(function () { reloadgruppeVerantwortlich(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('gruppeVerantwortlich', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'gruppeVerantwortlich', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_gruppeVerantwortlich" <?php \EasyEditor\Navigation::printScroll('dv.GruppeVerantwortlich', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_gruppeVerantwortlich\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_gruppeVerantwortlich\'] = wantedPage;
														reloadgruppeVerantwortlich(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style="" data-gruppeVerantwortlich-id="<?php echo htmlentities($item['ID']); ?>">

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox gruppeVerantwortlich__checkbox gruppeVerantwortlich__checkbox gruppeVerantwortlich__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="gruppeVerantwortlich__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="gruppeVerantwortlich__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checkgruppeVerantwortlich(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><button type="button" class="mdl-button mdl-js-button mdl-button--icon gruppeVerantwortlich__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-gruppeVerantwortlich-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\GruppeVerantwortlich::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/GruppeVerantwortlich/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadgruppeVerantwortlich(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="gruppeVerantwortlich" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\GruppeVerantwortlich::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadgruppeVerantwortlich();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												</div><?php
												
	
    
  }

  public static function getidsAction($col) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE (('.\FOP\Database::quote(\FOP\User::getGruppe()).') AND (COALESCE((SELECT (CASE WHEN '.\FOP\Database::quote(\FOP\User::getMitglied()).' THEN TRUE ELSE EXISTS (SELECT (TRUE) FROM '.qi('gruppeVerantwortlich').' '.qi('Wk3yjwJT').' WHERE '.qi('Wk3yjwJT').'.'.qi('gruppe').' = '.qi('qH3eMvH2').'.'.qi('ID').' AND (('.qi('Wk3yjwJT').'.'.qi('mitglied').') = ('.\FOP\Database::sessionVarSQL('user').')) LIMIT 1) END) FROM '.qi('gruppe').' '.qi('qH3eMvH2').' WHERE '.qi('qH3eMvH2').'.'.qi('ID').' = '.qi('gruppeVerantwortlich').'.'.qi('gruppe').' LIMIT 1), FALSE)) AND (COALESCE((SELECT ('.\FOP\Database::quote(\FOP\User::getGruppe()).') FROM '.qi('gruppe').' '.qi('4YNQbTPE').' WHERE '.qi('4YNQbTPE').'.'.qi('ID').' = '.qi('gruppeVerantwortlich').'.'.qi('gruppe').' LIMIT 1), FALSE)) AND ('.\FOP\Database::quote(\FOP\User::getGruppe()).')) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('gruppeVerantwortlich').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function getSQL($params) { 
    
    
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ID */ '.qi('ID').' AS '.qi('ID').',
									/* gruppe */ '.qi('gruppe').' AS '.qi('gruppe').',
									/* gruppe::canView */ '.qi('ref:gruppe').'.'.qi('gruppe:canView').' AS '.qi('gruppe::canView').',
									/* gruppe::description */ '.qi('ref:gruppe').'.'.qi('gruppe:description').' AS '.qi('gruppe::description').',
									/* mitglied */ '.qi('mitglied').' AS '.qi('mitglied').',
									/* mitglied::canView */ '.qi('ref:mitglied').'.'.qi('mitglied:canView').' AS '.qi('mitglied::canView').',
									/* mitglied::description */ '.qi('ref:mitglied').'.'.qi('mitglied:description').' AS '.qi('mitglied::description').',
									/* operation::create */ ('.\FOP\Database::quote(\FOP\User::getGruppe()).') AND (COALESCE((SELECT (CASE WHEN '.\FOP\Database::quote(\FOP\User::getMitglied()).' THEN TRUE ELSE EXISTS (SELECT (TRUE) FROM '.qi('gruppeVerantwortlich').' '.qi('Wk3yjwJT').' WHERE '.qi('Wk3yjwJT').'.'.qi('gruppe').' = '.qi('fBbeiLnC').'.'.qi('ID').' AND (('.qi('Wk3yjwJT').'.'.qi('mitglied').') = ('.\FOP\Database::sessionVarSQL('user').')) LIMIT 1) END) FROM '.qi('gruppe').' '.qi('fBbeiLnC').' WHERE '.qi('fBbeiLnC').'.'.qi('ID').' = '.qi('gruppeVerantwortlich').'.'.qi('gruppe').' LIMIT 1), FALSE)) AND (COALESCE((SELECT ('.\FOP\Database::quote(\FOP\User::getGruppe()).') FROM '.qi('gruppe').' '.qi('wyrUOtPx').' WHERE '.qi('wyrUOtPx').'.'.qi('ID').' = '.qi('gruppeVerantwortlich').'.'.qi('gruppe').' LIMIT 1), FALSE)) AND ('.\FOP\Database::quote(\FOP\User::getGruppe()).') AS '.qi('operation::create').',
									/* operation::delete */ ('.\FOP\Database::quote(\FOP\User::getGruppe()).') AND (COALESCE((SELECT (CASE WHEN '.\FOP\Database::quote(\FOP\User::getMitglied()).' THEN TRUE ELSE EXISTS (SELECT (TRUE) FROM '.qi('gruppeVerantwortlich').' '.qi('Wk3yjwJT').' WHERE '.qi('Wk3yjwJT').'.'.qi('gruppe').' = '.qi('qH3eMvH2').'.'.qi('ID').' AND (('.qi('Wk3yjwJT').'.'.qi('mitglied').') = ('.\FOP\Database::sessionVarSQL('user').')) LIMIT 1) END) FROM '.qi('gruppe').' '.qi('qH3eMvH2').' WHERE '.qi('qH3eMvH2').'.'.qi('ID').' = '.qi('gruppeVerantwortlich').'.'.qi('gruppe').' LIMIT 1), FALSE)) AND (COALESCE((SELECT ('.\FOP\Database::quote(\FOP\User::getGruppe()).') FROM '.qi('gruppe').' '.qi('4YNQbTPE').' WHERE '.qi('4YNQbTPE').'.'.qi('ID').' = '.qi('gruppeVerantwortlich').'.'.qi('gruppe').' LIMIT 1), FALSE)) AND ('.\FOP\Database::quote(\FOP\User::getGruppe()).') AS '.qi('operation::delete').',
									/* operation::edit */ ('.\FOP\Database::quote(\FOP\User::getGruppe()).') AND (COALESCE((SELECT (CASE WHEN '.\FOP\Database::quote(\FOP\User::getMitglied()).' THEN TRUE ELSE EXISTS (SELECT (TRUE) FROM '.qi('gruppeVerantwortlich').' '.qi('Wk3yjwJT').' WHERE '.qi('Wk3yjwJT').'.'.qi('gruppe').' = '.qi('MoiuP63r').'.'.qi('ID').' AND (('.qi('Wk3yjwJT').'.'.qi('mitglied').') = ('.\FOP\Database::sessionVarSQL('user').')) LIMIT 1) END) FROM '.qi('gruppe').' '.qi('MoiuP63r').' WHERE '.qi('MoiuP63r').'.'.qi('ID').' = '.qi('gruppeVerantwortlich').'.'.qi('gruppe').' LIMIT 1), FALSE)) AND (COALESCE((SELECT ('.\FOP\Database::quote(\FOP\User::getGruppe()).') FROM '.qi('gruppe').' '.qi('ZfLFIFaU').' WHERE '.qi('ZfLFIFaU').'.'.qi('ID').' = '.qi('gruppeVerantwortlich').'.'.qi('gruppe').' LIMIT 1), FALSE)) AND ('.\FOP\Database::quote(\FOP\User::getGruppe()).') AS '.qi('operation::edit').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ ('.\FOP\Database::quote(\FOP\User::getGruppe()).') AND (COALESCE((SELECT (CASE WHEN '.\FOP\Database::quote(\FOP\User::getMitglied()).' THEN TRUE ELSE NOT ((NOT (EXISTS (SELECT (TRUE) FROM '.qi('gruppeItem').' '.qi('hX7wRx63').' WHERE '.qi('hX7wRx63').'.'.qi('list').' = '.qi('30TxGBSm').'.'.qi('ID').' AND (('.qi('hX7wRx63').'.'.qi('item').') = ('.\FOP\Database::sessionVarSQL('user').')) LIMIT 1))) AND (NOT (EXISTS (SELECT (TRUE) FROM '.qi('gruppeVerantwortlich').' '.qi('yvRIjwTv').' WHERE '.qi('yvRIjwTv').'.'.qi('gruppe').' = '.qi('30TxGBSm').'.'.qi('ID').' AND (('.qi('yvRIjwTv').'.'.qi('mitglied').') = ('.\FOP\Database::sessionVarSQL('user').')) LIMIT 1))) AND (NOT ('.qi('30TxGBSm').'.'.qi('public').'))) END) FROM '.qi('gruppe').' '.qi('30TxGBSm').' WHERE '.qi('30TxGBSm').'.'.qi('ID').' = '.qi('gruppeVerantwortlich').'.'.qi('gruppe').' LIMIT 1), FALSE)) AS '.qi('operation::view').',
									1
								FROM '.qi('gruppeVerantwortlich').' '.qi('gruppeVerantwortlich').'
								LEFT JOIN (SELECT '.qi('ID').' AS '.qi('gruppe:ID').', '.qi('gruppe').'.'.qi('name').' AS '.qi('gruppe:description').', ((CASE WHEN '.\FOP\Database::quote(\FOP\User::getMitglied()).' THEN TRUE ELSE NOT ((NOT (EXISTS (SELECT (TRUE) FROM '.qi('gruppeItem').' '.qi('hX7wRx63').' WHERE '.qi('hX7wRx63').'.'.qi('list').' = '.qi('gruppe').'.'.qi('ID').' AND (('.qi('hX7wRx63').'.'.qi('item').') = ('.\FOP\Database::sessionVarSQL('user').')) LIMIT 1))) AND (NOT (EXISTS (SELECT (TRUE) FROM '.qi('gruppeVerantwortlich').' '.qi('yvRIjwTv').' WHERE '.qi('yvRIjwTv').'.'.qi('gruppe').' = '.qi('gruppe').'.'.qi('ID').' AND (('.qi('yvRIjwTv').'.'.qi('mitglied').') = ('.\FOP\Database::sessionVarSQL('user').')) LIMIT 1))) AND (NOT ('.qi('gruppe').'.'.qi('public').'))) END)) AS '.qi('gruppe:canView').' FROM '.qi('gruppe').') '.qi('ref:gruppe').' ON '.qi('ref:gruppe').'.'.qi('gruppe:ID').' = '.qi('gruppe').'
								LEFT JOIN (SELECT '.qi('ID').' AS '.qi('mitglied:ID').', CONCAT('.qi('mitglied').'.'.qi('vorname').', \' \', '.qi('mitglied').'.'.qi('name').') AS '.qi('mitglied:description').', ((CASE WHEN '.\FOP\Database::quote(\FOP\User::getGruppe()).' THEN TRUE ELSE NOT (('.qi('mitglied').'.'.qi('ID').') <> ('.\FOP\Database::sessionVarSQL('user').')) END) AND (CASE WHEN '.\FOP\Database::quote(\FOP\User::getMitglied()).' THEN TRUE ELSE NOT ((('.qi('mitglied').'.'.qi('ID').') <> ('.\FOP\Database::sessionVarSQL('user').')) AND (NOT (EXISTS (SELECT (TRUE) FROM '.qi('gruppeItem').' '.qi('7sncgH3z').' WHERE '.qi('7sncgH3z').'.'.qi('item').' = '.qi('mitglied').'.'.qi('ID').' AND (EXISTS (SELECT (TRUE) FROM '.qi('gruppeVerantwortlich').' '.qi('eHueOsQC').' WHERE '.qi('eHueOsQC').'.'.qi('gruppe').' = '.qi('7sncgH3z').'.'.qi('list').' AND (('.qi('eHueOsQC').'.'.qi('mitglied').') = ('.\FOP\Database::sessionVarSQL('user').')) LIMIT 1)) LIMIT 1)))) END) AND (CASE WHEN '.\FOP\Database::quote(\FOP\User::getSuperadmin()).' THEN TRUE ELSE NOT ('.qi('mitglied').'.'.qi('superadmin').') END)) AS '.qi('mitglied:canView').' FROM '.qi('mitglied').') '.qi('ref:mitglied').' ON '.qi('ref:mitglied').'.'.qi('mitglied:ID').' = '.qi('mitglied').'
								WHERE ((('.\FOP\Database::quote(\FOP\User::getGruppe()).') AND (COALESCE((SELECT (CASE WHEN '.\FOP\Database::quote(\FOP\User::getMitglied()).' THEN TRUE ELSE NOT ((NOT (EXISTS (SELECT (TRUE) FROM '.qi('gruppeItem').' '.qi('hX7wRx63').' WHERE '.qi('hX7wRx63').'.'.qi('list').' = '.qi('30TxGBSm').'.'.qi('ID').' AND (('.qi('hX7wRx63').'.'.qi('item').') = ('.\FOP\Database::sessionVarSQL('user').')) LIMIT 1))) AND (NOT (EXISTS (SELECT (TRUE) FROM '.qi('gruppeVerantwortlich').' '.qi('yvRIjwTv').' WHERE '.qi('yvRIjwTv').'.'.qi('gruppe').' = '.qi('30TxGBSm').'.'.qi('ID').' AND (('.qi('yvRIjwTv').'.'.qi('mitglied').') = ('.\FOP\Database::sessionVarSQL('user').')) LIMIT 1))) AND (NOT ('.qi('30TxGBSm').'.'.qi('public').'))) END) FROM '.qi('gruppe').' '.qi('30TxGBSm').' WHERE '.qi('30TxGBSm').'.'.qi('ID').' = '.qi('gruppeVerantwortlich').'.'.qi('gruppe').' LIMIT 1), FALSE))))) AS t
								LEFT JOIN '.qi('mitglied').' AS '.qi('sorter-mitglied').' ON t.'.qi('mitglied').' = '.qi('sorter-mitglied').'.'.qi('ID').'
								WHERE ' . (isset($params['filter_gruppeVerantwortlich_gruppe']) ? ($params['filter_gruppeVerantwortlich_gruppe'] !== '' ? ('(' . (new \FOP\IDList($params['filter_gruppeVerantwortlich_gruppe']))->toSQL('t.'.qi('gruppe').'') . ') AND ') : '') : '') . 
								(isset($params['filter_gruppeVerantwortlich_mitglied']) ? ($params['filter_gruppeVerantwortlich_mitglied'] !== '' ? ('(' . (new \FOP\IDList($params['filter_gruppeVerantwortlich_mitglied']))->toSQL('t.'.qi('mitglied').'') . ') AND ') : '') : '') . 
								(isset($params['filter_gruppeVerantwortlich_ID']) ? ($params['filter_gruppeVerantwortlich_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_gruppeVerantwortlich_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getfilter_gruppeVerantwortlich_gruppeItemsByStringAction($fstr) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		// Auf aktive DataView-Items einschränken
		$params = $_GET;
		unset($params['filter_gruppeVerantwortlich_gruppe']);
		return \Types\Gruppe::getItems(null, -1, $fstr, ''.qi('ID').' IN (SELECT DISTINCT t.'.qi('gruppe').''.self::getSQL($params).')');
	

    
  }

  public static function getfilter_gruppeVerantwortlich_mitgliedItemsByStringAction($fstr) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		// Auf aktive DataView-Items einschränken
		$params = $_GET;
		unset($params['filter_gruppeVerantwortlich_mitglied']);
		return \Types\Mitglied::getItems(null, -1, $fstr, ''.qi('ID').' IN (SELECT DISTINCT t.'.qi('mitglied').''.self::getSQL($params).')');
	

    
  }

  public static function getData($sqladdon, $params, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params);

								$order = (\FOP\Util::array_value(array(
									'mitglied ASC' => 'ORDER BY '.qi('sorter-mitglied').'.'.qi('name').' , '.qi('sorter-mitglied').'.'.qi('name').' , '.qi('sorter-mitglied').'.'.qi('name').' , '.qi('sorter-mitglied').'.'.qi('name').' , '.qi('sorter-mitglied').'.'.qi('name').' , '.qi('sorter-mitglied').'.'.qi('name').' , '.qi('sorter-mitglied').'.'.qi('name').' , '.qi('sorter-mitglied').'.'.qi('name').' , '.qi('sorter-mitglied').'.'.qi('name').' , '.qi('sorter-mitglied').'.'.qi('name').' , '.qi('sorter-mitglied').'.'.qi('name').' , '.qi('sorter-mitglied').'.'.qi('vorname').' , '.qi('sorter-mitglied').'.'.qi('vorname').' , '.qi('sorter-mitglied').'.'.qi('vorname').' , '.qi('sorter-mitglied').'.'.qi('vorname').' , '.qi('sorter-mitglied').'.'.qi('vorname').' , '.qi('sorter-mitglied').'.'.qi('vorname').' , '.qi('sorter-mitglied').'.'.qi('vorname').' , '.qi('sorter-mitglied').'.'.qi('vorname').' , '.qi('sorter-mitglied').'.'.qi('vorname').' , '.qi('sorter-mitglied').'.'.qi('vorname').' , '.qi('sorter-mitglied').'.'.qi('vorname').' ',
									'mitglied DESC' => 'ORDER BY '.qi('sorter-mitglied').'.'.qi('name').' DESC, '.qi('sorter-mitglied').'.'.qi('name').' DESC, '.qi('sorter-mitglied').'.'.qi('name').' DESC, '.qi('sorter-mitglied').'.'.qi('name').' DESC, '.qi('sorter-mitglied').'.'.qi('name').' DESC, '.qi('sorter-mitglied').'.'.qi('name').' DESC, '.qi('sorter-mitglied').'.'.qi('name').' DESC, '.qi('sorter-mitglied').'.'.qi('name').' DESC, '.qi('sorter-mitglied').'.'.qi('name').' DESC, '.qi('sorter-mitglied').'.'.qi('name').' DESC, '.qi('sorter-mitglied').'.'.qi('name').' DESC, '.qi('sorter-mitglied').'.'.qi('vorname').' DESC, '.qi('sorter-mitglied').'.'.qi('vorname').' DESC, '.qi('sorter-mitglied').'.'.qi('vorname').' DESC, '.qi('sorter-mitglied').'.'.qi('vorname').' DESC, '.qi('sorter-mitglied').'.'.qi('vorname').' DESC, '.qi('sorter-mitglied').'.'.qi('vorname').' DESC, '.qi('sorter-mitglied').'.'.qi('vorname').' DESC, '.qi('sorter-mitglied').'.'.qi('vorname').' DESC, '.qi('sorter-mitglied').'.'.qi('vorname').' DESC, '.qi('sorter-mitglied').'.'.qi('vorname').' DESC, '.qi('sorter-mitglied').'.'.qi('vorname').' DESC',
									'' => ''), isset($params['sort_gruppeVerantwortlich']) ? $params['sort_gruppeVerantwortlich'] : '') ?: '');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											$item['gruppe'] = \FOP\Sanitizers::null_converter($item['gruppe']);
											$item['mitglied'] = \FOP\Sanitizers::null_converter($item['mitglied']);
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										$item['gruppe'] = \FOP\Sanitizers::null_converter($item['gruppe']);
										$item['mitglied'] = \FOP\Sanitizers::null_converter($item['mitglied']);
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		if (isset($params['filter_gruppeVerantwortlich_gruppe'])) {
		if ($params['filter_gruppeVerantwortlich_gruppe'] == '_null') {
			array_push($filters, _('Gruppe') . ': ' . _(''));
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_gruppeVerantwortlich_gruppe']))->all() AS $val) {
				$value = 
  \FOP\Database::query('SELECT '.qi('gruppe').'.'.qi('name').' AS description FROM '.qi('gruppe').' WHERE '.qi('ID').' = ' . \FOP\Database::quote($val))->fetchColumn() ?: _('')
;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Gruppe') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_gruppeVerantwortlich_mitglied'])) {
		if ($params['filter_gruppeVerantwortlich_mitglied'] == '_null') {
			array_push($filters, _('Verantwortlich') . ': ' . _(''));
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_gruppeVerantwortlich_mitglied']))->all() AS $val) {
				$value = 
  \FOP\Database::query('SELECT CONCAT('.qi('mitglied').'.'.qi('vorname').', \' \', '.qi('mitglied').'.'.qi('name').') AS description FROM '.qi('mitglied').' WHERE '.qi('ID').' = ' . \FOP\Database::quote($val))->fetchColumn() ?: _('')
;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Verantwortlich') . ': ' . implode(', ', $values));
		}
	}
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_gruppeVerantwortlich_\')) delete query[q];} reloadgruppeVerantwortlich(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'gruppeVerantwortlich') {
	\FOP\Session::setPayload('dv-gruppeVerantwortlich', [
		'id' => 'gruppeVerantwortlich',
		'tbl' => 'gruppeVerantwortlich',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\GruppeVerantwortlich::stepURL('gruppeVerantwortlich', 'XXX', -1),
		'next' => \DataViewRouter\GruppeVerantwortlich::stepURL('gruppeVerantwortlich', 'XXX',  1),
		'from' => $fop_from
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\GruppeVerantwortlich::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



